#include <stdio.h>

/* Schaltjahr: Berechnet, ob das angegebene Jahr
 *             ein Schaltjahr war.
 * Parameter:
 *     jahr: Das Kalenderjahr
 * Rckgabewert: 0 ... kein Schaltjahr, 1 ... Schaltjahr
 */
long Schaltjahr(long jahr)
{  return ((jahr % 4 == 0) &&
           ((jahr % 100 != 0))) || (jahr % 400 == 0);
}  // end Schaltjahr

/* Kalendermonat: Gibt einen Kalendermonat aus
 * Parameter:
 *     anzahlTage: 28 <= anzahlTage <= 31
 *             Anzahl der Tage des Monats
 *     erster: 0=Mo, 1=Di, 2=Mi, 3=Do, 4=Fr, 5=Sa, 6=So
 *             bestimmt Wochentag des ersten Tag des Monats
 * Rckgabewert: Wochentag des 1. des Folgemonats
 *               0=Mo, 1=Di, 2=Mi, 3=Do, 4=Fr, 5=Sa, 6=So
 */
long KalenderMonat(long anzahlTage, long erster)
{  long tag;

   // Spaltenbeschriftung
   printf("  Mo  Di  Mi  Do  Fr  Sa  So\n");
   printf("----------------------------\n");

   // Einrcken des ersten Kalendertags
   printf("%*s", (int)(4 * erster), "");

   // Ausgabe des Kalenders
   for (tag = 1; tag <= anzahlTage; tag = tag + 1)
   {  printf("%4li", tag);
      if ((tag + erster) % 7 == 0)
         printf("\n");
   }
   printf("\n");

   return (tag + erster - 1) % 7;
}  // end KalenderMonat

/* KalenderJahr: Gibt ein Kalenderjahr aus
 * Parameter:
 *     jahr: > 0
 *            Jahreszahl
 *     erster: 0=Mo, 1=Di, 2=Mi, 3=Do, 4=Fr, 5=Sa, 6=So
 *             bestimmt Wochentag des ersten Tag des ersten Monats
 * Rckgabewert: Keiner
 */
void KalenderJahr(long jahr, long erster)
{  long monat, tage;

   printf("Jahr %ld:\n", jahr);
   for (monat = 1; monat <= 12; monat = monat + 1)
   {  switch(monat)
      {case 1:
       case 3:
       case 5:
       case 7:
       case 8:
       case 10:
       case 12:
         tage = 31;
         break;
       case 4:
       case 6:
       case 9:
       case 11:
         tage = 30;
         break;
       case 2:
         if (Schaltjahr(jahr))
            tage = 29;
         else
            tage = 28;
         break;
      }
      printf("Monat %ld:\n", monat);
      erster = KalenderMonat(tage, erster);
   }
}  // end KalenderJahr


main()
{  long jahr, erster;

   // Eingabe
   printf("Welches Jahr: ");
   scanf ("%ld", &jahr);
   printf("Welcher Wochentag war der 1. Jnner\n");
   printf("(0=Mo, 1=Di, 2=Mi, 3=Do, 4=Fr, 5=Sa, 6=So): ");
   scanf ("%ld", &erster);

   // Ausgabe eines Jahres
   printf("\n");
   KalenderJahr(jahr, erster);
}  // end main
